import { _decorator, Component, game, instantiate, Label, Node, Prefab, profiler } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('testNodes')
export class testNodes extends Component {
    @property(Prefab)
    testSP:Prefab  =null;
    @property(Node)
    spParent:Node = null;
    @property(Node)
    addBtn:Node  =null;
    @property(Node)
    fpsBtn:Node  =null;
    @property(Label)
    debugLabel:Label = null;

    private _currentNum = 0;

    start() {
        this.addSPs();
        profiler.showStats();
        this.addBtn.on(Node.EventType.TOUCH_END,this.addSPs,this);
        this.fpsBtn.on(Node.EventType.TOUCH_END,this.setFPS,this);

    }

    setFPS(){
        const fps = game.frameRate;
        game.frameRate = fps===60? 30:60;
    }

    addSPs(){
        for(var i =0;i<200;i++){
            this.addSP();
        }
        this._currentNum +=200;
        this.debugLabel.string = "Counts: "+this._currentNum;
    }

    addSP(){
        const sp = instantiate(this.testSP);
        sp.parent = this.spParent;
        sp.setPosition(-350+750*Math.random(),-667+1334*Math.random());
    }
}

